using PyCall
cv2=pyimport("cv2")
numpy=pyimport("numpy")
os=pyimport("os")

#创建人脸检测器和识别器
labels, faces = [], []
file = "lbpcascade_frontalface_improved.xml"
face_cascade = cv2.CascadeClassifier(file)
recognizer = cv2.face.LBPHFaceRecognizer_create()

function detect_face(image)
    #'''检测人脸区域'''
    gray = cv2.cvtColor(image, cv2.COLOR_BGR2GRAY)
    faces = face_cascade.detectMultiScale(gray, 1.2, 5, minSize=(20, 20))
    if (length(faces) == 0)
        return nothing
    end
    println(faces[:][1])
    (x, y, w, h) = faces[:]
    return gray[y:y+w, x:x+h]
end

function read_face(label, images_path)
    #'''读取人脸图像'''
    println("trainning:", label, images_path)
    files = os.listdir(images_path)
    for file in files
        if startswith(file,'.')
            continue
        end
        #从文件中读取图像
        image = cv2.imread(images_path * "/" * file)
        #检测图像中的人脸区域
        face = detect_face(image)
        
        if face !==nothing
            #println(size(face))
            face = cv2.resize(face, (256, 256))
            #faces.append(face)
            #labels.append(label)
            push!(faces,face)
            push!(labels,label)
        end
    end
end
#读取人脸图像
read_face(1, "training/spider_man/")
read_face(2, "training/iron_man/")
#训练人脸识别器
recognizer.train(faces, numpy.array(labels))
#保存人脸特征数据
recognizer.save("trainner.yml")